<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title>debconf5 | See you in hel</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css" media="all">@import "http://www.debconf.org/debconf5/misc/drupal.css";</style>
<style type="text/css">@import url(http://www.debconf.org/debconf5/modules/event/event.css);</style>
<link rel="alternate" type="application/rss+xml" title="RSS" href="http://www.debconf.org/debconf5/node/feed" />

  <style type="text/css" media="all">@import "http://www.debconf.org/debconf5/themes/debconf5/style.css";</style>

  <script type="text/javascript"> </script>
</head>

<body bgcolor="#ffffff" >

<div class="hide"><a href="http://www.debconf.org/debconf5/#content" title="Skip navigation." accesskey="2">Skip navigation</a>.</div>
      <!--a href="http://www.debconf.org/debconf5/" title="Home"><img src="http://www.debconf.org/debconf5/files/logo.png" alt="Home" width="144" height="63" border="0" /></a-->
      <!--div class='site-name'><a href="http://www.debconf.org/debconf5/./" title="Home">debconf5</a></div-->
<table id="top_line" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>

    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left_15.png"></td>
    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png"></td>
    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right_15.png"></td>
  </tr>
</table>
<table id="content" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>	
	<td colspan="5">
		<table id="primary-menu" summary="Navigation elements." border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>

		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left.png"></td>
		    <td class="top_left"><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_img.jpg"></a></td>
		    <td class="top_right" width="219" valign="top">
			   <table>
				<tr>
				  <td colspan="6"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="10"></td>
				</tr>
				<tr>
				  <td><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/home.jpg"></a></td>

				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/nav_divider.jpg"></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10" height="29"></td>
				  <td><a href="http://www.debconf.org/debconf5/search"><img src="http://www.debconf.org/debconf5/themes/debconf5/search.jpg"></a></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10"></td>
				</tr>
				<tr>
				  <td colspan="6"><form action="http://comas.linux-aktivaattori.org/comas/general/proposals/search" method="post">
    				    <div id="search">

  		  	 	  	<input class="form-text" type="text" size="15" value="" name="keys" alt="Enter the terms you wish to search for." />
    				      	<input class="form-submit" type="submit" value="Search" alt="submit" />
				        </div>
				      </form></td>	
				</tr>
			   </table>
			</td>
		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right.png"></td>
		  </tr>

		</table>
		<table id="bottom_line" border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>
		    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="7"></td>
		  </tr>
		</table>	
	</td>
  </tr>
  <tr>
  	<td colspan="5">
<div id="container">
<br/>
	<div id="comas" style="margin-left: 4%">


<h1>Cross-compiling application and creating Debian package for embeded systems</h1>

<h2>Proposal details:</h2>

<table class="comas-table" width=100%>

<tr>
<td class="name">Abstract:</td>
<td class="input"><p><div class="hft-lines">Cross-compiling application and creating Debian package for embedded systems.<br />
<br />
Carlos Eduardo de Souza Aguiar<br />
Joao Leite de Oliveira Neto<br />
Afonso Rabelo Costa Junior<br />
{carlos.aguiar, joao.leite, afonso.costa}@indt.org.br<br />
<br />
Abstract <br />
<br />
Nowadays, there isn't a pattern or a specific tool to make cross-compiling of applications from i386 platform to ARM platform. So, this process is usually difficult, wasting a lot of time and it's different from application to application.<br />
<br />
The propose of this tutorial is to show how the use of Scratchbox for cross-compiling and creation of Debian packages can be improved regarding the process of embedding applications for ARM platform.<br />
<br />
As a case study, we will show the process of cross-compiling target for ARM outside and inside Scratchbox, embedding Mozilla Minimo application on the OMAP&#153; development kit. The idea is to show how a development environment based in Debian inside Scratchbox can leverage the process of creation and embedding of applications for an embedded system.<br />
<br />
* Introduction<br />
<br />
Nowadays, there isn't a pattern or a specific tool to make cross-compiling of applications from i386 platform to ARM platform. So, this process is very hard, wasting a lot of time and it's different from application to application.<br />
<br />
The propose of this tutorial is to show how the use of Scratchbox  cross-compile and create  Debian packages can be improved for the process of embedding applications for ARM platform. <br />
<br />
* Cross-compiling target for ARM outside Scratchbox<br />
<br />
To cross-compile any application outside scratchbox, we previously  needed to create a toolchain for the specific target platform. <br />
<br />
To build this toolchain we need to follow some steps, roughly described below: <br />
<br />
- Compile the linux source using all necessary patches for the target platform.<br />
- Compile binutils <br />
- Compile gcc bootstrap <br />
- Compile glibc <br />
- Compile gcc with threads and c++ <br />
- Re-compile the kernel source to apply the changes above.<br />
<br />
These are the main steps. The major problem in this process is  that a lot of time can be spent compiling the toolchain for a specific platform. So the process to embed an application to a specific platform can be quite hard and time consuming.<br />
<br />
* Scratchbox<br />
<br />
Scratchbox [1] is a cross-compilation toolkit designed to make embedded Linux application development easier. Scratchbox also provides a full set of tools to integrate and cross-compile an entire Linux distribution.<br />
<br />
* Debian development with Scratchbox<br />
<br />
Debian GNU/Linux [2] is developed and maintained in a collaborative way with the work of thousands of individuals around the world. Enriched with tools like Debian devkit, rootstrap, fakeroot and others features,  scratchbox offers easy way to use build environment for debian development. With scratchbox, we can achieve faster compilation (and cross-compilation) times and easier testing of packages for specific architectures, such as ARM. As a result, the development pace using Scratchbox can be significantly faster.<br />
<br />
* Cross-compiling target for ARM inside Scratchbox<br />
<br />
Basically, to make a cross-compilation target for ARM inside Scratchbox, you should do the following steps:<br />
<br />
        - Create a target;<br />
        - Choose a toolchain to compile the programs. In our case, the compiler is gcc for ARM (arm gcc glibc);<br />
        - Choose the CPU-Transparency method. In our case, we used 'qemu-arm' emulator.<br />
<br />
After these steps, Scratchbox is now ready for cross-compilation target ARM with QEMU emulator. <br />
<br />
* Generate Debian Package inside Scratchbox <br />
<br />
The Debian development inside Scratchbox is done through Debian devkit. Debian devkit offers tools for creating Debian pakages and rootstraps in the same way they are created on a native Debian system.<br />
<br />
You need install the 'scratchbox-devkit-debian' package in order to do Debian development.<br />
<br />
* Case Study<br />
<br />
As a case study, we will show a way to cross-compile Mozilla Minimo [3] target for ARM outside Scratchbox using an ARM filesystem, through a NFS Server that should be mounted in a specific directory (for example, /armfs_debian) in a desktop distribution. Both ARM filesystem and desktop distribution are based in Debian. To cross-compile Mozilla Minimo, you should edit the mozconfig-arm, available in  There are a lot of problems in this way of cross-compiling, for example, to manually  setup the paths of libraries environment and flags. So, this is a hard task, wasting a lot of time and there's no a pattern to do this.<br />
<br />
We will show here a way to make this cross-compilation using Scratchbox, that provide us an environment to develop applications in a easy and pattern way all based in Debian.<br />
<br />
About the authors:<br />
The authors of this tutorial are developing desktop application (for i386 platform) and embedding (for ARM platform), based on Debian system. They are contributors to the development and improvement of Mozilla Minimo and GTK+ libraries, making the use of a environment development fully based on Debian and the mailing lists (Minimo and GTK+).<br />
<br />
References<br />
<br />
[1] Scratchbox cross-compilation toolkit website. http://www.scratchbox.org/<br />
[2] Debian GNU/Linux website. http://www.debian.org<br />
[3] Minimo Project. http://www.mozilla.org/projects/minimo/<br /></div></p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Presentation type:</td>
<td class="input"><p>BOF (45 min)</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Track:</td>
<td class="input"><p>Technical</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Status:</td>
<td class="input"><p>Non-official (i.e. BoF)</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

</table>

<h2>Authors:</h2>

<ul>

<li><p>Carlos Aguiar</p>


</li>

<li><p>Joao Leite</p>


</li>

<li><p>Afonso Costa</p>


</li>

</ul>

<h2>Files:</h2>

<ul>

</ul>

<center>
<input type="button" value="Go back" onClick="history.go(-1)">
</center>

	</div>
<br/>
<hr/>
</div>
<div id="bottom" class="margin-left: 4%">
&nbsp;<a href="http://www.debconf.org/debconf5">Debconf 5</a><br/> 
&nbsp;&nbsp;&nbsp;Powered by <a href="http://gborg.postgresql.org/project/comas">COMAS</a>, 
the Conference Management System by <a href="http://www.consol.org.mx">CONSOL</a>
</div>
</td>
</tr>
</table>

</body>
</html>

